import ddf.minim.spi.*;
import ddf.minim.signals.*;
import ddf.minim.*;
import ddf.minim.analysis.*;
import ddf.minim.ugens.*;
import ddf.minim.effects.*;


Horse [] horses = new Horse[1];
float x;
float y;
float w;
float h;
float ang;
float ang1;
float ang2;
float ang3;
float l;
float l1;
float l2;
float l3;
float r1;
float g1;
float b1;
float a1;

PShape horse;
Minim minim;
AudioPlayer play;

void setup() {
  size(700, 700);
  background(200);
  rectMode(CENTER);
  rect(350, 350, 300, 200);

  horse = loadShape("horse.svg");
  minim = new Minim(this);
  play = minim.loadFile("garyedstrom__merry-go-round.wav");

  r1=random(255);
  g1=random(255);
  b1=random(255);
  a1=random(155);

  for (int i=0; i<horses.length; i++) {
    horse.scale(.5);
    for (int i2=0; i2< (play.bufferSize ()-1)/15; i2++) {
    float sicl = play.left.get(i2)*30;
    float sicr = play.right.get(i2)*50;
    horses[i] = new Horse(300, 300, random(255), random(255), random(255), 126);
    horses[i] = new Horse(-300, -300, random(255), random(255), random(255), 126);

    }
  }
}

void draw() {
  background(200);
  
  play.play();


  rectMode(CORNER);
  translate(width/2, height/2);
  //  float ag = map(30, x, 0, 450, 0);
  ang = ang + .001;
  ang1 = ang1 + .01;
  ang2 = ang2 + .1;
  ang3 = ang3 + 1;
  l = l/2 - tan(ang);
  l1 = l1/2 - tan(ang1);
  l2 = l2/2 - tan(ang2);
  l3 = l3/2 - tan(ang3);


  if (l>=random(150, 600)) {
    l = l - cos(ang);
  } else if (l<=-random(150, 600)) {
    l = l + cos(ang);
  }

  for (int i=0; i<horses.length; i++) {
    translate(x,x);
    horses[i].dplay();
    horses[i].mov();
  }

  horse.disableStyle();


  println(l3);

  rotate(PI/l);


  for (int i=0; i<1; i++) {
    rotate(PI/3.0);
    //    stroke(l3+100);
    //    strokeWeight(8);
    //    noStroke();
    fill(250-random(-l, l), 100-random(-l, l), 100-random(-l, l), 230+l3);
    quad(x, x, x-40, x+160, x, x+200+(l1/3), x+40, x+160);
    quad(x, x, x-160, x-40, x-200-(l1/3), x, x-160, x+40);
    quad(x, x, x-40, x-160, x, x-200-(l1/3), x+40, x-160);
    quad(x, x, x+160, x-40, x+200+(l1/3), x, x+160, x+40);

    rotate(.52);
    fill(250-random(-l, l), 200-random(-l, l), 100-random(-l, l), 230+l3);
    quad(x, x, x-40, x+160, x, x+200+(l1/3), x+40, x+160);
    quad(x, x, x-160, x-40, x-200-(l1/3), x, x-160, x+40);
    quad(x, x, x-40, x-160, x, x-200-(l1/3), x+40, x-160);
    quad(x, x, x+160, x-40, x+200+(l1/3), x, x+160, x+40);


    rotate(.53);
    fill(155-random(-l, l), 200-random(-l, l), 200-random(-l, l), 230+l3);
    quad(x, x, x-40, x+160, x, x+200+(l1/3), x+40, x+160);
    quad(x, x, x-160, x-40, x-200-(l1/3), x, x-160, x+40);
    quad(x, x, x-40, x-160, x, x-200-(l1/3), x+40, x-160);
    quad(x, x, x+160, x-40, x+200+(l1/3), x, x+160, x+40);
  }

  for (int i=0; i<3; i++) {
    noStroke();
    rotate(PI/3.0);
    rectMode(CENTER);
    fill(255+l3);
    rect(x, x, 20, 20);

    fill(255-l, 0+random(-l, l), 127+l, 230);
    rectMode(CORNER);
    noStroke();
    rect(x-20, x-20, 20, 20);
    fill(255, 4);
    rect(x-19, x-19, 20, 20);
    fill(l-random(-i, i), l-random(-i, i), l-random(-i, i), 5);
    rect(x, x, -10, -50);
    rect(x-1, x-1, -70, -10);
    fill((120)+l1+random(-i, i), (120)+l2+random(-i, i), (120)+l3*2+random(-i, i));
    ellipse(x-60, x-60, 10, 10);

    fill(255-l, 0+random(-l, l), 127+l, 230);
    noStroke();
    rect(x, x, 20, 20);
    fill(255, 4);
    rect(x-1, x-1, 20, 20);
    fill(l-random(-i, i), l-random(-i, i), l-random(-i, i), 5);
    rect(x+1, x+1, 10, 50);
    rect(x+1, x+1, 70, 10);
    fill((120)+l1+random(-i, i), (120)+l2+random(-i, i), (120)+l3*2+random(-i, i));
    ellipse(x+60, x+60, 10, 10);


    fill(255-l, 0+random(-l, l), 127+l, 230);
    noStroke();
    rect(x, x, -20, 20);
    fill(255, 4);
    rect(x+1, x+1, -20, 20);
    fill(l-random(-i, i), l-random(-i, i), l-random(-i, i), 5);
    rect(x, x, -10, 70);
    rect(x, x, -50, 10);
    fill((120)+l1+random(-i, i), (120)+l2+random(-i, i), (120)+l3*2+random(-i, i));
    ellipse(x-60, x+60, 10, 10);

    fill(255-l, 0+random(-l, l), 127+l, 230);
    noStroke();
    rect(x, x, 20, -20);
    fill(255, 4);
    rect(x-1, x-1, 20, -20);
    rect(x+1, x, 50, -10);
    rect(x+1, x+1, 10, -70);
    fill((120)+l1+random(-i, i), (120)+l2+random(-i, i), (120)+l3*2+random(-i, i));
    ellipse(x+60, x-60, 10, 10);
  }






  //  rect(195,250,10,200);
  //  rect(270,250,10,200);
  //  rect(345,250,10,200);
  //  rect(420,250,10,200);
  //  rect(495,250,10,200);
  //  
  //  ellipse(200,250,20,20);
  //  ellipse(275,250,20,20);
  //  ellipse(350,250,20,20);
  //  ellipse(425,250,20,20);
  //  ellipse(500,250,20,20);
  //  
  //  
  //  ellipse(200,450,20,20);
  //  ellipse(275,450,20,20);
  //  ellipse(350,450,20,20);
  //  ellipse(425,450,20,20);
  //  ellipse(500,450,20,20);
  //  
  println(127+r1);

  //  cil(300,300,300,300,300);
}


class Horse {
  float x2;
  float y2;
  float r2;
  float g2;
  float b2;
  float a2;

  Horse(float _x, float _y, float _r, float _g, float _b, float _a) {
    x2 = _x;
    y2 = _y;
    r2 = _r;
    g2 = _g;
    b2 = _b;
    a2 = _a;
  }

  void dplay() {

    horse.tint(color(227, 100, 45, 255));
//    rotate(PI/l);
    shape(horse, x2, y2);


    //  cilynder.beginShape();
    //  cilynder.fill(255);
    //  cilynder.bezierVertex(cx, cy, cx+20, cy+100, cx+40, cy+120);
    //  //  cilynder.bezierVertex(100,100);
    //  cilynder.endShape();
  }
  void mov() {
//    y2= y2 + .1;
//    rotate(y2);
    rotate(PI/3.0);
   for (int i2=0; i2< (play.bufferSize ()-1)/30; i2++){
    float sicl = play.left.get(i2)*30;
    float sicr = play.right.get(i2)*50;
    rotate(PI/(l/10));
    y2 = sicl;
    
    if (y2>100 ){
     y2= y2 -sicl; 
    } else if (y2<0){
     y2= y2 +sicl; 
    }
    }
  }
}


